    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------------
    028     * KeyedValueComparatorType.java
    029     * -----------------------------
    030     * (C) Copyright 2003-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: KeyedValueComparatorType.java,v 1.3.2.1 2005/10/25 21:29:13 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 05-Mar-2003 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.data;
    044
    045
    046    /**
    047     * Used to indicate the type of a {@link KeyedValueComparator} : 'by key' or
    048     * 'by value'.
    049     */
    050    public final class KeyedValueComparatorType {
    051
    052        /** An object representing 'by key' sorting. */
    053        public static final KeyedValueComparatorType BY_KEY
    054            = new KeyedValueComparatorType("KeyedValueComparatorType.BY_KEY");
    055
    056        /** An object representing 'by value' sorting. */
    057        public static final KeyedValueComparatorType BY_VALUE
    058            = new KeyedValueComparatorType("KeyedValueComparatorType.BY_VALUE");
    059
    060        /** The name. */
    061        private String name;
    062
    063        /**
    064         * Private constructor.
    065         *
    066         * @param name  the name.
    067         */
    068        private KeyedValueComparatorType(String name) {
    069            this.name = name;
    070        }
    071
    072        /**
    073         * Returns a string representing the object.
    074         *
    075         * @return The string.
    076         */
    077        public String toString() {
    078            return this.name;
    079        }
    080
    081        /**
    082         * Returns <code>true</code> if this object is equal to the specified
    083         * object, and <code>false</code> otherwise.
    084         *
    085         * @param o  the other object.
    086         *
    087         * @return A boolean.
    088         */
    089        public boolean equals(Object o) {
    090            if (this == o) {
    091                return true;
    092            }
    093            if (!(o instanceof KeyedValueComparatorType)) {
    094                return false;
    095            }
    096
    097            KeyedValueComparatorType type = (KeyedValueComparatorType) o;
    098            if (!this.name.equals(type.name)) {
    099                return false;
    100            }
    101
    102            return true;
    103        }
    104
    105        /**
    106         * Returns a hash code.
    107         *
    108         * @return A hash code.
    109         */
    110        public int hashCode() {
    111            return this.name.hashCode();
    112        }
    113    }
    114